=== debian/changelog ===
casablanca (2.9.1-1build1) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:10:22 +0000

casablanca (2.9.1-1) unstable; urgency=medium

  * New upstream minor release, fixing the license on
    header files.
  * Patch refresh

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 04 Nov 2016 08:30:20 +0100

casablanca (2.9.0-4) unstable; urgency=medium

  [ Kurt Roeckx ]
  * debian/patches/285.patch:
    - conditionalize the openssl version to avoid
      deprecated calls.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 03 Nov 2016 21:16:21 +0100
